package org.lazywizard.console;

import java.util.ArrayList;
import java.util.List;

class PersistentCommandManager
{
    // Whether combat toggle commands should stay on for subsequent battles
    private static boolean PERSISTENT_COMBAT_COMMANDS = false;
    private static boolean needPluginRecheck = false;
    private static final List<PersistentCommand> commands = new ArrayList<>();

    static void setCommandPersistence(boolean persistent)
    {
        PERSISTENT_COMBAT_COMMANDS = persistent;
    }

    private static void checkPlugins()
    {
        System.out.println("Should check plugins now.");
        needPluginRecheck = false;
        // TODO
        /*// Add plugins that should be active
         Set<Class<? extends BaseCombatTogglePlugin>> toAdd = new HashSet<>();
         for (BaseCombatTogglePlugin tmp : activePlugins)
         {
         toAdd.add(tmp.getClass());
         }
         toAdd.removeAll(plugins);

         for (Class<? extends BaseCombatTogglePlugin> tmp : toAdd)
         {
         try
         {
         BaseCombatTogglePlugin cmd = cmdClass.newInstance();
         activePlugins.add(cmd);
         cmd.onActivate(engine);
         }
         catch (InstantiationException | IllegalAccessException ex)
         {
         Console.showException("Failed to instantiate combat plugin '"
         + cmdClass.getCanonicalName() + "':", ex);
         plugins.remove();
         }
         }

         // Add plugins that should be active
         for (Iterator<Class<? extends BaseCombatTogglePlugin>> iter
         = plugins.values().iterator(); iter.hasNext();)
         {
         Class<? extends BaseCombatTogglePlugin> cmdClass = iter.next();
         try
         {
         BaseCombatTogglePlugin cmd = cmdClass.newInstance();
         activePlugins.add(cmd);
         cmd.onActivate(engine);
         }
         catch (InstantiationException | IllegalAccessException ex)
         {
         Console.showException("Failed to instantiate combat plugin '"
         + cmdClass.getCanonicalName() + "':", ex);
         iter.remove();
         }
         }*/
    }

    static void advance(float amount, ConsoleListener listener)
    {
        if (needPluginRecheck)
        {
            checkPlugins();
        }
    }

    public static interface PersistentCommand
    {
        public abstract void onActivate();

        public abstract void advance(float amount);

        public abstract void onDeactivate();
    }
}
